DCMTK: DSRTree< T > Class Template Reference

DCMTK Version 3.6.9 OFFIS DICOM Toolkit

Loading...
Searching...
No Matches
Public Member Functions | Protected Member Functions | Private Attributes | List of all members
DSRTree< T > Class Template Reference

Class managing a tree of nodes. More...

Inheritance diagram for DSRTree< T >:

## Public Member Functions
| DSRTree ()
| default constructor
| DSRTree (const DSRTree< T > &tree)
| copy constructor.
virtual | ~DSRTree ()
| destructor
DSRTree & | operator= (DSRTree< T > tree)
| assignment operator.
virtual void | clear ()
| clear all member variables, i.e. the tree with all nodes
void | clearAnnotations ()
| clear annotations of all tree nodes
OFBool | isEmpty () const
| check whether tree has any nodes
size_t | countNodes () const
| count number of nodes in the tree.
size_t | getNextNodeID () const
| get ID of the next node to be created.
size_t | gotoRoot ()
| set internal cursor to root node
size_t | gotoNode (const size_t searchID, const OFBool startFromRoot=OFTrue)
| set internal cursor to specified node
size_t | gotoNode (const OFString &reference, const OFBool startFromRoot=OFTrue)
| set internal cursor to specified node
size_t | gotoNode (const DSRTreeNodeAnnotation &annotation, const OFBool startFromRoot=OFTrue)
| set internal cursor to specified node
size_t | gotoNode (const T &nodeValue, const OFBool startFromRoot=OFTrue)
| set internal cursor to specified node (given by its value).
virtual size_t | addNode (T *node, const E_AddMode addMode=AM_afterCurrent)
| add new node to the current one.
virtual size_t | replaceNode (T *node)
| replace current node by the given one.
virtual T * | extractNode ()
| extract current node from tree.
virtual T * | getAndRemoveRootNode ()
| get pointer to root node and "forget" the internal reference to this node.
virtual size_t | removeNode ()
| remove current node from tree.
virtual DSRTree< T > * | extractSubTree ()
| extract a subtree, i.e. a fragment from this tree.
virtual DSRTree< T > * | cloneSubTree (const size_t stopAfterNodeID=0) const
| clone a subtree, i.e. a fragment of this tree.
Public Member Functions inherited from DSRTreeNodeCursor< DSRTreeNode >
| DSRTreeNodeCursor ()
| default constructor
| DSRTreeNodeCursor (const DSRTreeNodeCursor< DSRTreeNode > &cursor)
| copy constructor
| DSRTreeNodeCursor (DSRTreeNode *node, const DSRPositionCounter *position=NULL)
| constructor.
virtual | ~DSRTreeNodeCursor ()
| destructor
DSRTreeNodeCursor< DSRTreeNode > & | operator= (const DSRTreeNodeCursor< DSRTreeNode > &cursor)
| assignment operator
DSRTreeNodeCursor< DSRTreeNode > & | operator= (DSRTreeNode *node)
| assignment operator.
virtual OFBool | isValid () const
| check whether cursor currently points to a valid node
virtual size_t | countChildNodes (const OFBool searchIntoSub=OFTrue) const
| count number of children of the current node.
OFBool | hasParentNode () const
| check whether the current node has a parent
OFBool | hasChildNodes () const
| check whether the current node has any children
OFBool | hasPreviousNode () const
| check whether the current node has a preceding sibling
OFBool | hasNextNode () const
| check whether the current node has a following sibling
OFBool | hasSiblingNodes () const
| check whether the current node has any siblings
virtual DSRTreeNode * | getNode () const
| get pointer to current node
virtual const DSRTreeNode * | getParentNode () const
| get pointer to parent node.
virtual const DSRTreeNode * | getChildNode () const
| get pointer to first child node.
virtual const DSRTreeNode * | getPreviousNode () const
| get pointer to previous node.
virtual const DSRTreeNode * | getNextNode () const
| get pointer to next node.
virtual size_t | gotoFirst ()
| goto first node on the same level (first sibling).
virtual size_t | gotoLast ()
| goto last node on the same level (last sibling).
virtual size_t | gotoPrevious ()
| goto previous node on the same level (preceding sibling)
virtual size_t | gotoNext ()
| goto next node on the same level (following sibling)
virtual size_t | goUp ()
| goto parent node (one level up)
virtual size_t | goDown ()
| goto first child node (one level down)
virtual size_t | gotoParent ()
| goto parent node (one level up)
virtual size_t | gotoChild ()
| goto first child node (one level down)
virtual size_t | iterate (const OFBool searchIntoSub=OFTrue)
| iterate over all nodes (starting from current position!)
size_t | gotoNode (const size_t searchID)
| set cursor to specified node.
size_t | gotoNode (const OFString &position, const char separator='.')
| set cursor to specified node.
size_t | gotoNode (const DSRTreeNodeAnnotation &annotation)
| set cursor to specified node.
size_t | gotoNode (const DSRTreeNode &nodeValue)
| set cursor to specified node.
size_t | getNodeID () const
| get current node ID.
size_t | getLevel () const
| get current level.
DSRPositionCounter & | getPositionCounter ()
| get reference to internal position counter.
const OFString & | getPosition (OFString &position, const char separator='.') const
| get position string of the current node.

## Protected Member Functions
| DSRTree (T *rootNode)
| special constructor that receives a pointer to the root node.
| DSRTree (const DSRTreeNodeCursor< T > &startCursor, size_t stopAfterNodeID)
| special copy constructor that clones a particular subtree only
void | swap (DSRTree< T > &tree)
| fast, non-throwing swap function.
virtual T * | getRoot () const
| get pointer to root node
virtual void | deleteTreeFromRootNode (T *rootNode)
| delete a tree given by its root node.
Protected Member Functions inherited from DSRTreeNodeCursor< DSRTreeNode >
void | swap (DSRTreeNodeCursor< DSRTreeNode > &cursor)
| fast, non-throwing swap function.
void | clearNodeCursorStack ()
| clear the internal node cursor stack
const DSRTreeNodeCursor< DSRTreeNode > & | getCursor () const
| get cursor
void | setCursor (const DSRTreeNodeCursor< DSRTreeNode > &cursor)
| set cursor to specified object
size_t | setCursor (DSRTreeNode *node)
| set cursor to specified node.
DSRTreeNode * | getChild () const
| get pointer to first child node
virtual | ~DSRTypes ()
| destructor.

## Private Attributes
T * | RootNode
| pointer to the root tree node

## Additional Inherited Members
Protected Types inherited from DSRTypes
enum | E_DocumentType { DT_invalid , DT_unknown = DT_invalid , DT_BasicTextSR , DT_EnhancedSR , DT_ComprehensiveSR , DT_KeyObjectSelectionDocument , DT_MammographyCadSR , DT_ChestCadSR , DT_ColonCadSR , DT_ProcedureLog , DT_XRayRadiationDoseSR , DT_EnhancedXRayRadiationDoseSR , DT_SpectaclePrescriptionReport , DT_MacularGridThicknessAndVolumeReport , DT_ImplantationPlanSRDocument , DT_Comprehensive3DSR , DT_RadiopharmaceuticalRadiationDoseSR , DT_ExtensibleSR , DT_AcquisitionContextSR , DT_SimplifiedAdultEchoSR , DT_PatientRadiationDoseSR , DT_PerformedImagingAgentAdministrationSR , DT_PlannedImagingAgentAdministrationSR , DT_RenditionSelectionDocument , DT_WaveformAnnotationSR , DT_last = DT_WaveformAnnotationSR }
| SR document types (DICOM IOD) More...
enum | E_RelationshipType { RT_invalid , RT_unknown , RT_isRoot , RT_contains , RT_hasObsContext , RT_hasAcqContext , RT_hasConceptMod , RT_hasProperties , RT_inferredFrom , RT_selectedFrom , RT_last = RT_selectedFrom }
| SR relationship types. More...
enum | E_ValueType { VT_invalid , VT_Text , VT_Code , VT_Num , VT_DateTime , VT_Date , VT_Time , VT_UIDRef , VT_PName , VT_SCoord , VT_SCoord3D , VT_TCoord , VT_Composite , VT_Image , VT_Waveform , VT_Container , VT_byReference , VT_includedTemplate , VT_last = VT_includedTemplate }
| SR value types. More...
enum | E_PresentationStateType { PT_invalid , PT_unknown = PT_invalid , PT_Grayscale , PT_Color , PT_PseudoColor , PT_Blending , PT_XAXRFGrayscale , PT_GrayscalePlanarMPR , PT_CompositingPlanarMPR , PT_AdvancedBlending , PT_VolumeRendering , PT_SegmentedVolumeRendering , PT_MultipleVolumeRendering , PT_VariableModalityLUT , PT_last = PT_VariableModalityLUT }
| Softcopy presentation state types. More...
enum | E_GraphicType { GT_invalid , GT_unknown = GT_invalid , GT_Point , GT_Multipoint , GT_Polyline , GT_Circle , GT_Ellipse , GT_last = GT_Ellipse }
| SR graphic types. More...
enum | E_GraphicType3D { GT3_invalid , GT3_unknown = GT3_invalid , GT3_Point , GT3_Multipoint , GT3_Polyline , GT3_Polygon , GT3_Ellipse , GT3_Ellipsoid , GT3_last = GT3_Ellipsoid }
| SR graphic types (3D). More...
enum | E_TemporalRangeType { TRT_invalid , TRT_unknown = TRT_invalid , TRT_Point , TRT_Multipoint , TRT_Segment , TRT_Multisegment , TRT_Begin , TRT_End , TRT_last = TRT_End }
| SR temporal range types. More...
enum | E_ContinuityOfContent { COC_invalid , COC_Separate , COC_Continuous , COC_last = COC_Continuous }
| SR continuity of content flag. More...
enum | E_PreliminaryFlag { PF_invalid , PF_Preliminary , PF_Final , PF_last = PF_Final }
| SR document preliminary flag. More...
enum | E_CompletionFlag { CF_invalid , CF_Partial , CF_Complete , CF_last = CF_Complete }
| SR document completion flag. More...
enum | E_VerificationFlag { VF_invalid , VF_Unverified , VF_Verified , VF_last = VF_Verified }
| SR document verification flag. More...
enum | E_CharacterSet { CS_invalid , CS_unknown = CS_invalid , CS_ASCII , CS_default = CS_ASCII , CS_Latin1 , CS_Latin2 , CS_Latin3 , CS_Latin4 , CS_Cyrillic , CS_Arabic , CS_Greek , CS_Hebrew , CS_Latin5 , CS_Latin9 , CS_Thai , CS_Japanese , CS_Korean , CS_ChineseISO , CS_ChineseGB18030 , CS_ChineseGBK , CS_UTF8 , CS_last = CS_UTF8 }
| Specific character set. More...
enum | E_CodeValueType { CVT_auto , CVT_Short , CVT_Long , CVT_URN }
| Code value type. More...
enum | E_AddMode { AM_afterCurrent , AM_beforeCurrent , AM_belowCurrent , AM_belowCurrentBeforeFirstChild }
| Add node mode. More...
static const char * | documentTypeToSOPClassUID (const E_DocumentType documentType)
| convert SR document type to SOP class UID
static const char * | documentTypeToModality (const E_DocumentType documentType)
| convert SR document type to modality
static const char * | documentTypeToReadableName (const E_DocumentType documentType)
| convert SR document type to readable name.
static const char * | documentTypeToDocumentTitle (const E_DocumentType documentType, OFString &documentTitle)
| convert SR document type to document title.
static OFBool | requiresEnhancedEquipmentModule (const E_DocumentType documentType)
| check whether a given SR document type requires the Enhanced General Equipment Module
static OFBool | requiresTimezoneModule (const E_DocumentType documentType)
| check whether a given SR document type requires the Timezone Module
static OFBool | requiresSynchronizationModule (const E_DocumentType documentType)
| check whether a given SR document type requires the Synchronization Module
static OFBool | usesSRDocumentSeriesModule (const E_DocumentType documentType)
| check whether a given SR document type uses the SR Document Series Module (instead of the Key Object Document Series Module)
static OFBool | usesKeyObjectDocumentSeriesModule (const E_DocumentType documentType)
| check whether a given SR document type uses the Key Object Document Series Module (instead of the SR Document Series Module)
static OFBool | usesSRDocumentGeneralModule (const E_DocumentType documentType)
| check whether a given SR document type uses the SR Document General Module (instead of the Key Object Document Module)
static OFBool | usesKeyObjectDocumentModule (const E_DocumentType documentType)
| check whether a given SR document type uses the Key Object Document Module (instead of the SR Document General Module)
static const char * | relationshipTypeToDefinedTerm (const E_RelationshipType relationshipType)
| convert relationship type to DICOM defined term
static const char * | relationshipTypeToReadableName (const E_RelationshipType relationshipType)
| convert relationship type to readable name.
static const char * | valueTypeToDefinedTerm (const E_ValueType valueType)
| convert value type to DICOM defined term
static const char * | valueTypeToXMLTagName (const E_ValueType valueType)
| convert value type to XML tag name
static const char * | valueTypeToReadableName (const E_ValueType valueType)
| convert value type to readable name.
static const char * | presentationStateTypeToShortName (const E_PresentationStateType pstateType)
| convert presentation state type to short name.
static const char * | graphicTypeToEnumeratedValue (const E_GraphicType graphicType)
| convert graphic type to DICOM enumerated value
static const char * | graphicTypeToReadableName (const E_GraphicType graphicType)
| convert graphic type to readable name.
static const char * | graphicType3DToEnumeratedValue (const E_GraphicType3D graphicType)
| convert graphic type (3D) to DICOM enumerated value
static const char * | graphicType3DToReadableName (const E_GraphicType3D graphicType)
| convert graphic type (3D) to readable name.
static const char * | temporalRangeTypeToEnumeratedValue (const E_TemporalRangeType temporalRangeType)
| convert temporal range type to DICOM enumerated value
static const char * | temporalRangeTypeToReadableName (const E_TemporalRangeType temporalRangeType)
| convert temporal range type to readable name.
static const char * | continuityOfContentToEnumeratedValue (const E_ContinuityOfContent continuityOfContent)
| convert continuity of content flag to DICOM enumerated value
static const char * | preliminaryFlagToEnumeratedValue (const E_PreliminaryFlag preliminaryFlag)
| convert preliminary flag to DICOM enumerated value
static const char * | completionFlagToEnumeratedValue (const E_CompletionFlag completionFlag)
| convert completion flag to DICOM enumerated value
static const char * | verificationFlagToEnumeratedValue (const E_VerificationFlag verificationFlag)
| convert verification flag to DICOM enumerated value
static const char * | characterSetToDefinedTerm (const E_CharacterSet characterSet)
| convert character set to DICOM defined term
static const char * | characterSetToHTMLName (const E_CharacterSet characterSet)
| convert character set to HTML name.
static const char * | characterSetToXMLName (const E_CharacterSet characterSet)
| convert character set to XML name.
static E_DocumentType | sopClassUIDToDocumentType (const OFString &sopClassUID)
| convert SOP class UID to SR document type
static E_RelationshipType | definedTermToRelationshipType (const OFString &definedTerm)
| convert DICOM defined term to relationship type
static E_ValueType | definedTermToValueType (const OFString &definedTerm)
| convert DICOM defined term to value type
static E_PresentationStateType | sopClassUIDToPresentationStateType (const OFString &sopClassUID)
| convert SOP class UID to presentation state type
static E_ValueType | xmlTagNameToValueType (const OFString &xmlTagName)
| convert XML tag name to value type
static E_GraphicType | enumeratedValueToGraphicType (const OFString &enumeratedValue)
| convert DICOM enumerated value to graphic type
static E_GraphicType3D | enumeratedValueToGraphicType3D (const OFString &enumeratedValue)
| convert DICOM enumerated value to graphic type (3D)
static E_TemporalRangeType | enumeratedValueToTemporalRangeType (const OFString &enumeratedValue)
| convert DICOM enumerated value to temporal range type
static E_ContinuityOfContent | enumeratedValueToContinuityOfContent (const OFString &enumeratedValue)
| convert DICOM enumerated value to continuity of content flag
static E_PreliminaryFlag | enumeratedValueToPreliminaryFlag (const OFString &enumeratedValue)
| convert DICOM enumerated value to preliminary flag
static E_CompletionFlag | enumeratedValueToCompletionFlag (const OFString &enumeratedValue)
| convert DICOM enumerated value to completion flag
static E_VerificationFlag | enumeratedValueToVerificationFlag (const OFString &enumeratedValue)
| convert DICOM enumerated value to verification flag
static E_CharacterSet | definedTermToCharacterSet (const OFString &definedTerm)
| convert DICOM defined term to character set.
static OFBool | isDocumentTypeSupported (const E_DocumentType documentType)
| check whether specified SR document type is supported by this library
static const OFString & | currentDate (OFString &dateString)
| get current date in DICOM 'DA' format.
static const OFString & | currentTime (OFString &timeString)
| get current time in DICOM 'TM' format.
static const OFString & | currentDateTime (OFString &dateTimeString)
| get current date and time in DICOM 'DT' format.
static const OFString & | localTimezone (OFString &timezoneString)
| get local timezone in DICOM format.
static const OFString & | dicomToReadableDate (const OFString &dicomDate, OFString &readableDate)
| convert DICOM date string to readable format.
static const OFString & | dicomToReadableTime (const OFString &dicomTime, OFString &readableTime)
| convert DICOM time string to readable format.
static const OFString & | dicomToReadableDateTime (const OFString &dicomDateTime, OFString &readableDateTime)
| convert DICOM date time string to readable format.
static const OFString & | dicomToReadablePersonName (const OFString &dicomPersonName, OFString &readablePersonName)
| convert DICOM person name to readable format.
static const OFString & | dicomToXMLPersonName (const OFString &dicomPersonName, OFString &xmlPersonName, const OFBool writeEmptyValue=OFFalse)
| convert DICOM person name to XML format.
static const char * | numberToString (const size_t number, char *stringValue, size_t stringLength)
| convert unsigned integer number to character string
static size_t | stringToNumber (const char *stringValue)
| convert string to unsigned integer number
static const OFString & | convertToPrintString (const OFString &sourceString, OFString &printString)
| convert character string to print string.
static const OFString & | convertToHTMLString (const OFString &sourceString, OFString &markupString, const size_t flags=0, const OFBool newlineAllowed=OFFalse)
| convert character string to HTML mnenonic string.
static const OFString & | convertToXMLString (const OFString &sourceString, OFString &markupString)
| convert character string to XML mnenonic string.
static OFBool | checkForValidReference (const OFString &stringValue)
| check string for valid reference (as used for by-reference relationships).
static DSRIODConstraintChecker * | createIODConstraintChecker (const E_DocumentType documentType)
| create specified SR IOD content relationship constraint checker object.
static DSRDocumentTreeNode * | createDocumentTreeNode (const E_RelationshipType relationshipType, const E_ValueType valueType)
| create specified document tree node.
static OFCondition | addElementToDataset (OFCondition &result, DcmItem &dataset, DcmElement *delem, const OFString &vm, const OFString &type, const char *moduleName=NULL)
| add given element to the dataset.
static void | removeAttributeFromSequence (DcmSequenceOfItems &sequence, const DcmTagKey &tagKey)
| remove given attribute from the sequence.
static OFCondition | getElementFromDataset (DcmItem &dataset, DcmElement &delem)
| get element from dataset
static const char * | getStringValueFromElement (const DcmElement &delem)
| get string value from element
static const OFString & | getStringValueFromElement (const DcmElement &delem, OFString &stringValue)
| get string value from element.
static OFCondition | getStringValueFromElement (const DcmElement &delem, OFString &stringValue, const signed long pos)
| get string value from element
static const OFString & | getPrintStringFromElement (const DcmElement &delem, OFString &stringValue)
| get string value from element and convert to "print" format.
static const OFString & | getMarkupStringFromElement (const DcmElement &delem, OFString &stringValue, const OFBool convertNonASCII=OFFalse)
| get string value from element and convert to HTML/XML.
static OFCondition | getStringValueFromDataset (DcmItem &dataset, const DcmTagKey &tagKey, OFString &stringValue, const signed long pos=0)
| get string value from dataset
static OFCondition | putStringValueToDataset (DcmItem &dataset, const DcmTag &tag, const OFString &stringValue, const OFBool allowEmpty=OFTrue)
| put string value to dataset
static OFBool | checkElementValue (DcmElement *delem, const DcmTagKey &tagKey, const OFString &vm, const OFString &type, const OFCondition &searchCond=EC_Normal, const char *moduleName=NULL, const OFBool acceptViolation=OFFalse)
| check element value for correct value multiplicity and type.
static OFBool | checkElementValue (DcmElement &delem, const OFString &vm, const OFString &type, const OFCondition &searchCond=EC_Normal, const char *moduleName=NULL, const OFBool acceptViolation=OFFalse)
| check element value for correct value multiplicity and type.
static OFCondition | getAndCheckElementFromDataset (DcmItem &dataset, DcmElement &delem, const OFString &vm, const OFString &type, const char *moduleName=NULL, const OFBool acceptViolation=OFFalse)
| get element from dataset and check it for correct value multiplicity and type.
static OFCondition | getAndCheckStringValueFromDataset (DcmItem &dataset, const DcmTagKey &tagKey, OFString &stringValue, const OFString &vm, const OFString &type, const char *moduleName=NULL, const OFBool acceptViolation=OFFalse)
| get string value from dataset and check it for correct value multiplicity and type.
static void | printInvalidContentItemMessage (const char *action, const DSRDocumentTreeNode *node, const char *location=NULL)
| print the warning message that the current content item is invalid/incomplete.
static void | printContentItemErrorMessage (const char *action, const OFCondition &result, const DSRDocumentTreeNode *node, const char *location=NULL)
| print an error message for the current content item.
static void | printUnknownValueWarningMessage (const char *valueName, const char *readValue=NULL, const char *action="Reading")
| print a warning message that an unknown/unsupported value has been determined
static OFBool | writeStringValueToXML (STD_NAMESPACE ostream &stream, const OFString &stringValue, const OFString &tagName, const OFBool writeEmptyValue=OFFalse)
| write string value to XML output stream.
static OFBool | writeStringFromElementToXML (STD_NAMESPACE ostream &stream, DcmElement &delem, const OFString &tagName, const OFBool writeEmptyValue=OFFalse)
| write string value from DICOM element to XML output stream.
static size_t | createHTMLAnnexEntry (STD_NAMESPACE ostream &docStream, STD_NAMESPACE ostream &annexStream, const OFString &referenceText, size_t &annexNumber, const size_t flags=0)
| create an HTML annex entry with hyperlinks.
static size_t | createHTMLFootnote (STD_NAMESPACE ostream &docStream, STD_NAMESPACE ostream &footnoteStream, size_t &footnoteNumber, const size_t nodeID, const size_t flags=0)
| create an HTML footnote with hyperlinks
static OFCondition | appendStream (STD_NAMESPACE ostream &mainStream, OFOStringStream &tempStream, const char *heading=NULL)
| append one output stream to another.
Protected Attributes inherited from DSRTreeNodeCursor< DSRTreeNode >
DSRTreeNode * | NodeCursor
| pointer to current node
OFStack< DSRTreeNode * > | NodeCursorStack
| stack of node pointers. Used to store the cursor position of upper levels.
DSRPositionCounter | Position
| counter for the current position within the current level and on upper levels
Static Protected Attributes inherited from DSRTypes
static const size_t | RF_readDigitalSignatures
| read digital signatures from dataset
static const size_t | RF_acceptUnknownRelationshipType
| accept unknown/missing relationship type
static const size_t | RF_acceptInvalidContentItemValue
| accept invalid content item value (e.g. violation of VR or VM definition)
static const size_t | RF_ignoreRelationshipConstraints
| ignore relationship constraints for this document class
static const size_t | RF_ignoreContentItemErrors
| do not abort on content item errors (e.g. missing value type specific attributes)
static const size_t | RF_skipInvalidContentItems
| do not abort when detecting an invalid content item, skip invalid sub-tree instead
static const size_t | RF_showCurrentlyProcessedItem
| show the currently processed content item (e.g. "1.2.3")
static const size_t | HF_neverExpandChildrenInline
| external: never expand child nodes inline
static const size_t | HF_alwaysExpandChildrenInline
| external: always expand child nodes inline
static const size_t | HF_renderInlineCodes
| external: render codes even if they appear inline
static const size_t | HF_useCodeDetailsTooltip
| external: render code details as a tooltip (not with HTML 3.2)
static const size_t | HF_renderConceptNameCodes
| external: render concept name codes (default: code meaning only)
static const size_t | HF_renderNumericUnitCodes
| external: render the code of the numeric measurement unit
static const size_t | HF_useCodeMeaningAsUnit
| external: use code meaning for the numeric measurement unit (default: code value)
static const size_t | HF_renderPatientTitle
| external: use patient information as document title (default: document type)
static const size_t | HF_renderNoDocumentHeader
| external: render no general document information (header)
static const size_t | HF_renderDcmtkFootnote
| external: render dcmtk/dcmsr comment at the end of the document
static const size_t | HF_renderFullData
| external: render the full data of all content items
static const size_t | HF_renderSectionTitlesInline
| external: render section titles inline (default: separate paragraph)
static const size_t | HF_copyStyleSheetContent
| external: copy Cascading Style Sheet (CSS) content to HTML file
static const size_t | HF_HTML32Compatibility
| external: output compatible to HTML version 3.2 (default: 4.01)
static const size_t | HF_XHTML11Compatibility
| external: output compatible to XHTML version 1.1 (default: HTML 4.01)
static const size_t | HF_addDocumentTypeReference
| external: add explicit reference to HTML document type (DTD)
static const size_t | HF_omitGeneratorMetaElement
| external: omit generator meta element referring to the DCMTK
static const size_t | HF_renderItemsSeparately
| internal: render items separately (for container with SEPARATE flag)
static const size_t | HF_renderItemInline
| internal: expand items inline when they are short and have no child nodes
static const size_t | HF_currentlyInsideAnnex
| internal: content item is rendered fully inside the annex
static const size_t | HF_createFootnoteReferences
| internal: create footnote references
static const size_t | HF_convertNonASCIICharacters
| internal: convert non-ASCII characters (> #127) to &#nnn;
static const size_t | HF_renderAllCodes
| shortcut: render all codes
static const size_t | HF_internalUseOnly
| shortcut: filter all flags that are only used internally
static const size_t | XF_writeEmptyTags
| write: write all tags even if their value is empty
static const size_t | XF_writeTemplateIdentification
| write: write template identification information (TID and mapping resource)
static const size_t | XF_alwaysWriteItemIdentifier
| write: always write item identifier "id", not only when item is referenced
static const size_t | XF_codeComponentsAsAttribute
| write: encode code value, coding scheme designator and coding scheme version as attribute instead of element text
static const size_t | XF_relationshipTypeAsAttribute
| write: encode relationship type as attribute instead of element text
static const size_t | XF_valueTypeAsAttribute
| write: encode value type as attribute instead of element text
static const size_t | XF_templateIdentifierAsAttribute
| write: encode template identifier as attribute instead of element text
static const size_t | XF_useDcmsrNamespace
| write: add DCMSR namespace declaration to the XML output
static const size_t | XF_addSchemaReference
| write: add Schema reference to XML document
static const size_t | XF_validateSchema
| read: validate content of XML document against Schema
static const size_t | XF_templateElementEnclosesItems
| read/write: template identification element encloses content items
static const size_t | XF_addCommentsForIncludedTemplate
| write: add comments with details at beginning/end of included template (might be useful for debugging purposes)
static const size_t | XF_acceptEmptyStudySeriesInstanceUID
| read: accept empty Study/Series/SOP Instance UID attribute values (must be filled later)
static const size_t | XF_encodeEverythingAsAttribute
| shortcut: combines all XF_xxxAsAttribute write flags (see above)
static const size_t | PF_printItemPosition
| print item position ("1.2.3") instead of line indentation
static const size_t | PF_shortenLongItemValues
| shorten long item value (e.g. long texts)
static const size_t | PF_printSOPInstanceUID
| print SOP instance UID of referenced objects
static const size_t | PF_printConceptNameCodes
| print coding scheme designator/version and code value of concept names
static const size_t | PF_printNoDocumentHeader
| print no general document information (header)
static const size_t | PF_printTemplateIdentification
| print template identification (TID and mapping resource)
static const size_t | PF_useANSIEscapeCodes
| use ANSI escape codes for output
static const size_t | PF_printLongSOPClassName
| print long SOP class name of referenced objects (default: short name for images)
static const size_t | PF_printSOPClassUID
| print SOP class UID of referenced objects (instead of the name)
static const size_t | PF_printInvalidCodes
| print code triple for invalid codes (instead of the text "invalid code")
static const size_t | PF_printNodeID
| print node ID at the beginning of each line (might be useful for debugging purposes)
static const size_t | PF_indicateEnhancedEncodingMode
| indicate with a "*" that the "enhanced encoding mode" is used for codes
static const size_t | PF_printAnnotation
| print annotation of a content item (optional, e.g. user-defined information)
static const size_t | PF_hideIncludedTemplateNodes
| do not print internal "included template" nodes (position counter is still increased)
static const size_t | PF_dontCountIncludedTemplateNodes
| do not count internal "included template" nodes (only with PF_hideIncludedTemplateNodes)
static const size_t | PF_printEmptyCodes
| print text "empty code" for empty codes (instead of "invalid code")
static const size_t | PF_printAllCodes
| shortcut: print all codes (combines all PF_printXxxCodes flags, see above)
static const size_t | CM_updatePositionString
| update the position string using the node ID
static const size_t | CM_updateNodeID
| update the node ID using the position string
static const size_t | CM_resetReferenceTargetFlag
| reset the reference target flag for all nodes
static const size_t | CB_maskPrintFlags
| bit mask (filter) for valid print flags (see PF_xxx)
static const size_t | CB_maskReadFlags
| bit mask (filter) for valid read flags (see RF_xxx)

## Detailed Description

template<typename T = DSRTreeNode>
class DSRTree< T >

Class managing a tree of nodes.

## Constructor & Destructor Documentation

## ◆ DSRTree() [1/3]

template<typename T>

DSRTree< T >::DSRTree | ( | const DSRTree< T > & | tree | ) |

copy constructor.

Please note that the internal cursor is not copied but reset, i.e. set to the root node.

Parameters

  tree | tree to be copied

References DSRTree(), DSRTreeNodeCursor< DSRTreeNode >::DSRTreeNodeCursor(), gotoRoot(), isEmpty(), and RootNode.

## ◆ DSRTree() [2/3]

template<typename T>

DSRTree< T >::DSRTree | ( | T * | rootNode | ) |
| protected

special constructor that receives a pointer to the root node.

Please note that the 'rootNode' and the associated tree is not copied!

Parameters

  rootNode | pointer to the root node of the "new" tree

References DSRTreeNodeCursor< DSRTreeNode >::DSRTreeNodeCursor(), gotoRoot(), and RootNode.

## ◆ DSRTree() [3/3]

template<typename T>

DSRTree< T >::DSRTree | ( | const DSRTreeNodeCursor< T > & | startCursor,
|  | size_t | stopAfterNodeID )
| protected

special copy constructor that clones a particular subtree only

Parameters

  startCursor | cursor pointing to first node of the subtree to be copied
  stopAfterNodeID | ID of the node after which the cloning should stop

References DSRTreeNodeCursor< DSRTreeNode >::DSRTreeNodeCursor(), addNode(), DSRTypes::AM_afterCurrent, DSRTypes::AM_belowCurrent, OFStack< T >::empty(), DSRTreeNodeCursor< T >::getNode(), gotoRoot(), DSRTreeNodeCursor< DSRTreeNode >::goUp(), OFStack< T >::pop(), OFStack< T >::push(), RootNode, and OFStack< T >::top().

## Member Function Documentation

## ◆ addNode()

template<typename T>

size_t DSRTree< T >::addNode | ( | T * | node,
|  | const E_AddMode | addMode = AM_afterCurrent )
| virtual

add new node to the current one.

Please note that no copy of the given node is created. Therefore, the node should be created with new() - do not use a reference to a local variable. If the node could be added successfully, the cursor is set to it automatically.

Parameters

  node | pointer to the new node to be added
  addMode | flag specifying at which position to add the new node

Returns
  ID of the new node if successful, 0 otherwise

Reimplemented in DSRDocumentSubTree.

References DSRTypes::AM_afterCurrent, DSRTypes::AM_beforeCurrent, DSRTypes::AM_belowCurrent, DSRTypes::AM_belowCurrentBeforeFirstChild, DSRTreeNode::Next, DSRTreeNodeCursor< DSRTreeNode >::NodeCursor, DSRTreeNodeCursor< DSRTreeNode >::NodeCursorStack, DSRTreeNodeCursor< DSRTreeNode >::Position, DSRTreeNode::Prev, and RootNode.

Referenced by DSRTree().

## ◆ cloneSubTree()

template<typename T>

DSRTree< T > * DSRTree< T >::cloneSubTree | ( | const size_t | stopAfterNodeID = 0 | ) | const
| virtual

clone a subtree, i.e. a fragment of this tree.

The cloning starts with the current node and ends with the given node.

Parameters

  stopAfterNodeID | ID of the node after which the cloning should stop. By default (0), the process ends after cloning the current node with all of its child nodes (if any).

Returns
  pointer to a copy of the specified subtree, NULL in case of error

Reimplemented in DSRDocumentSubTree.

References DSRTree(), and DSRTreeNodeCursor< DSRTreeNode >::NodeCursor.

## ◆ countNodes()

template<typename T>

size_t DSRTree< T >::countNodes | ( |  | ) | const

count number of nodes in the tree.

This method iterates over all nodes that are stored in the tree.

Returns
  number of nodes, 0 if tree is empty

References DSRTreeNodeCursor< DSRTreeNode >::DSRTreeNodeCursor(), DSRTreeNodeCursor< T >::isValid(), DSRTreeNodeCursor< T >::iterate(), and RootNode.

## ◆ deleteTreeFromRootNode()

template<typename T>

void DSRTree< T >::deleteTreeFromRootNode | ( | T * | rootNode | ) |
| protectedvirtual

delete a tree given by its root node.

Please note that the given 'rootNode' pointer becomes invalid afterwards.

Parameters

  rootNode | pointer to the root node of the tree to be deleted

References DSRTree().

Referenced by replaceNode().

## ◆ extractNode()

template<typename T>

T * DSRTree< T >::extractNode | ( |  | ) |
| virtual

extract current node from tree.

Please note that not only the specified node but also all of its child nodes are extracted from the tree. The cursor is set automatically to a new valid position.

Returns
  pointer to extracted node, NULL in case of error (or the tree was empty)

Reimplemented in DSRDocumentSubTree.

References DSRTreeNode::Down, DSRTreeNode::Next, DSRTreeNodeCursor< DSRTreeNode >::NodeCursor, DSRTreeNodeCursor< DSRTreeNode >::NodeCursorStack, DSRTreeNodeCursor< DSRTreeNode >::Position, and RootNode.

Referenced by extractSubTree(), and removeNode().

## ◆ extractSubTree()

template<typename T>

DSRTree< T > * DSRTree< T >::extractSubTree | ( |  | ) |
| virtual

extract a subtree, i.e. a fragment from this tree.

The subtree is specified by the current node, which becomes the root of the subtree.

Returns
  pointer to the extracted subtree, NULL in case of error

Reimplemented in DSRDocumentSubTree.

References DSRTree(), and extractNode().

## ◆ getAndRemoveRootNode()

template<typename T>

T * DSRTree< T >::getAndRemoveRootNode | ( |  | ) |
| virtual

get pointer to root node and "forget" the internal reference to this node.

In other words: after calling this method, the stored tree will be empty. This also means that the caller is responsible for deleting the allocated memory.

Returns
  pointer to root node, might be NULL (empty tree)

Reimplemented in DSRDocumentSubTree.

References RootNode.

## ◆ getNextNodeID()

template<typename T>

size_t DSRTree< T >::getNextNodeID | ( |  | ) | const
| inline

get ID of the next node to be created.

The node ID uniquely identifies a content item in the document tree.

Returns
  ID of the next node to be created (should never be 0)

References DSRTreeNode::getIdentCounter().

## ◆ getRoot()

template<typename T>

T * DSRTree< T >::getRoot | ( |  | ) | const
| protectedvirtual

get pointer to root node

Returns
  pointer to root node, might be NULL (empty tree)

References RootNode.

## ◆ gotoNode() [1/4]

template<typename T>

size_t DSRTree< T >::gotoNode | ( | const DSRTreeNodeAnnotation & | annotation,
|  | const OFBool | startFromRoot = OFTrue )

set internal cursor to specified node

Parameters

  annotation | annotation of the node to set the cursor to
  startFromRoot | flag indicating whether to start from the root node or the current one

Returns
  ID of the new current node if successful, 0 otherwise

References DSRTreeNodeCursor< T >::gotoNode(), gotoRoot(), and DSRTreeNodeAnnotation::isEmpty().

## ◆ gotoNode() [2/4]

template<typename T>

size_t DSRTree< T >::gotoNode | ( | const OFString & | reference,
|  | const OFBool | startFromRoot = OFTrue )

set internal cursor to specified node

Parameters

  reference | position string of the node to set the cursor to. (the format is e.g. "1.2.3" for the third child of the second child of the first node - see DSRTreeNodeCursor).
  startFromRoot | flag indicating whether to start from the root node or the current one

Returns
  ID of the new current node if successful, 0 otherwise

References OFString::empty(), DSRTreeNodeCursor< T >::gotoNode(), and gotoRoot().

## ◆ gotoNode() [3/4]

template<typename T>

size_t DSRTree< T >::gotoNode | ( | const size_t | searchID,
|  | const OFBool | startFromRoot = OFTrue )

set internal cursor to specified node

Parameters

  searchID | ID of the node to set the cursor to
  startFromRoot | flag indicating whether to start from the root node or the current one

Returns
  ID of the new current node if successful, 0 otherwise

References DSRTreeNodeCursor< T >::gotoNode(), and gotoRoot().

## ◆ gotoNode() [4/4]

template<typename T>

size_t DSRTree< T >::gotoNode | ( | const T & | nodeValue,
|  | const OFBool | startFromRoot = OFTrue )

set internal cursor to specified node (given by its value).

This method requires that T implements the comparison operator "not equal".

Parameters

  nodeValue | value of the node to set the cursor to
  startFromRoot | flag indicating whether to start from the root node or the current one

Returns
  ID of the new current node if successful, 0 otherwise

References DSRTreeNodeCursor< T >::gotoNode(), and gotoRoot().

## ◆ gotoRoot()

template<typename T>

size_t DSRTree< T >::gotoRoot | ( |  | ) |
| inline

set internal cursor to root node

Returns
  ID of root node if successful, 0 otherwise

References RootNode, and DSRTreeNodeCursor< DSRTreeNode >::setCursor().

Referenced by DSRTree(), DSRTree(), DSRTree(), clear(), gotoNode(), gotoNode(), gotoNode(), and gotoNode().

## ◆ isEmpty()

template<typename T>

OFBool DSRTree< T >::isEmpty | ( |  | ) | const
| inline

check whether tree has any nodes

Returns
  OFTrue if tree is empty, OFFalse otherwise

References RootNode.

Referenced by DSRTree().

## ◆ operator=()

template<typename T>

DSRTree< T > & DSRTree< T >::operator= | ( | DSRTree< T > | tree | ) |

assignment operator.

Please note that internally the copy constructor is used, so the same comments apply.

Parameters

  tree | tree to be copied

Returns
  reference to this tree after copying

References DSRTree(), and swap().

## ◆ removeNode()

template<typename T>

size_t DSRTree< T >::removeNode | ( |  | ) |
| virtual

remove current node from tree.

Please note that not only the specified node but also all of its child nodes are removed from the tree and then deleted. The cursor is set automatically to a new valid position.

Returns
  ID of the node which became the current one after deletion, 0 if an error occurred or the tree is now empty.

Reimplemented in DSRDocumentSubTree.

References OFStack< T >::empty(), extractNode(), DSRTreeNodeCursor< DSRTreeNode >::NodeCursor, OFStack< T >::pop(), OFStack< T >::push(), and OFStack< T >::top().

Referenced by clear().

## ◆ replaceNode()

template<typename T>

size_t DSRTree< T >::replaceNode | ( | T * | node | ) |
| virtual

replace current node by the given one.

Please note that no copy of the given node is created. Therefore, the node should be created with new() - do not use a reference to a local variable. If the node could be replaced successfully, the "old" node (and all of its child nodes) are deleted, and the cursor is set to the new one.

Parameters

  node | pointer to the new node to replace the current one

Returns
  ID of the new node if successful, 0 otherwise

Reimplemented in DSRDocumentSubTree.

References deleteTreeFromRootNode(), DSRTreeNode::Down, DSRTreeNode::Next, DSRTreeNodeCursor< DSRTreeNode >::NodeCursor, DSRTreeNodeCursor< DSRTreeNode >::NodeCursorStack, and RootNode.

## ◆ swap()

template<typename T>

void DSRTree< T >::swap | ( | DSRTree< T > & | tree | ) |
| protected

fast, non-throwing swap function.

The time complexity of this function is constant.

Parameters

  tree | tree to swap with

References DSRTree(), OFswap(), RootNode, and DSRTreeNodeCursor< T >::swap().

Referenced by operator=().

The documentation for this class was generated from the following file:

- dcmsr/include/dcmtk/dcmsr/dsrtree.h

Generated on Sat Mar 1 2025 for DCMTK Version 3.6.9 by Doxygen 1.13.2